type token =
    DROP
  | CAN
  | ASSERT
  | EXIT
  | SAVE
  | RESTORE
  | REMOVE
  | FORGET
  | RESET
  | SYMTAB
  | SIG
  | VALID
  | UNSAT
  | TYPE
  | SIGMA
  | SOLVE
  | HELP
  | DEF
  | TOGGLE
  | SET
  | TRACE
  | UNTRACE
  | CMP
  | FIND
  | USE
  | INV
  | SOLUTION
  | PARTITION
  | SHOW
  | CNSTRNT
  | SYNTAX
  | COMMANDS
  | SPLIT
  | DISEQ
  | CTXT
  | EOF
  | ARITH
  | TUPLE
  | IDENT of (string)
  | INTCONST of (int)
  | RATCONST of (Mpa.Q.t)
  | IN
  | BOT
  | INT
  | NONINT
  | REAL
  | BV
  | TOP
  | INF
  | NEGINF
  | ALBRA
  | ACLBRA
  | CLBRA
  | LPAR
  | RPAR
  | LBRA
  | RBRA
  | LCUR
  | RCUR
  | UNDERSCORE
  | KLAMMERAFFE
  | COLON
  | COMMA
  | DOT
  | DDOT
  | ASSIGN
  | UNION
  | TO
  | ENDMARKER
  | BACKSLASH
  | BVCONST of (string)
  | FRESH of (string * int)
  | FREE of (int)
  | CONC
  | SUB
  | BWITE
  | BWAND
  | BWOR
  | BWXOR
  | BWIMP
  | BWIFF
  | BWNOT
  | BVCONC
  | EQUAL
  | TRUE
  | FALSE
  | PLUS
  | MINUS
  | TIMES
  | DIVIDE
  | EXPT
  | LESS
  | GREATER
  | LESSOREQUAL
  | GREATEROREQUAL
  | UNSIGNED
  | APPLY
  | LAMBDA
  | WITH
  | CONS
  | CAR
  | CDR
  | NIL
  | INL
  | INR
  | OUTL
  | OUTR
  | INJ
  | OUT
  | HEAD
  | TAIL
  | LISTCONS
  | DISJ
  | XOR
  | IMPL
  | BIIMPL
  | CONJ
  | NEG
  | PROJ

open Parsing
# 21 "../../src/parser.mly"
  open Mpa
  open Tools

let out = Istate.outchannel

let pr str =  Format.fprintf (out()) str

let nl () = pr "\n"

let equal_width_of a b =
 match Istate.width_of a, Istate.width_of a with
   | Some(n), Some(m) when n = m -> n
   | Some(n), None -> n
   | None, Some(n) -> n
   | Some _, Some _ ->
       raise (Invalid_argument "Argument mismatch")
   | None, None -> 
       raise (Invalid_argument (Term.to_string a ^ " not a bitvector."))


(* Line 24, file ../../src/parser.ml *)
let yytransl_const = [|
  257 (* DROP *);
  258 (* CAN *);
  259 (* ASSERT *);
  260 (* EXIT *);
  261 (* SAVE *);
  262 (* RESTORE *);
  263 (* REMOVE *);
  264 (* FORGET *);
  265 (* RESET *);
  266 (* SYMTAB *);
  267 (* SIG *);
  268 (* VALID *);
  269 (* UNSAT *);
  270 (* TYPE *);
  271 (* SIGMA *);
  272 (* SOLVE *);
  273 (* HELP *);
  274 (* DEF *);
  275 (* TOGGLE *);
  276 (* SET *);
  277 (* TRACE *);
  278 (* UNTRACE *);
  279 (* CMP *);
  280 (* FIND *);
  281 (* USE *);
  282 (* INV *);
  283 (* SOLUTION *);
  284 (* PARTITION *);
  285 (* SHOW *);
  286 (* CNSTRNT *);
  287 (* SYNTAX *);
  288 (* COMMANDS *);
  289 (* SPLIT *);
  290 (* DISEQ *);
  291 (* CTXT *);
    0 (* EOF *);
  292 (* ARITH *);
  293 (* TUPLE *);
  297 (* IN *);
  298 (* BOT *);
  299 (* INT *);
  300 (* NONINT *);
  301 (* REAL *);
  302 (* BV *);
  303 (* TOP *);
  304 (* INF *);
  305 (* NEGINF *);
  306 (* ALBRA *);
  307 (* ACLBRA *);
  308 (* CLBRA *);
  309 (* LPAR *);
  310 (* RPAR *);
  311 (* LBRA *);
  312 (* RBRA *);
  313 (* LCUR *);
  314 (* RCUR *);
  315 (* UNDERSCORE *);
  316 (* KLAMMERAFFE *);
  317 (* COLON *);
  318 (* COMMA *);
  319 (* DOT *);
  320 (* DDOT *);
  321 (* ASSIGN *);
  322 (* UNION *);
  323 (* TO *);
  324 (* ENDMARKER *);
  325 (* BACKSLASH *);
  329 (* CONC *);
  330 (* SUB *);
  331 (* BWITE *);
  332 (* BWAND *);
  333 (* BWOR *);
  334 (* BWXOR *);
  335 (* BWIMP *);
  336 (* BWIFF *);
  337 (* BWNOT *);
  338 (* BVCONC *);
  339 (* EQUAL *);
  340 (* TRUE *);
  341 (* FALSE *);
  342 (* PLUS *);
  343 (* MINUS *);
  344 (* TIMES *);
  345 (* DIVIDE *);
  346 (* EXPT *);
  347 (* LESS *);
  348 (* GREATER *);
  349 (* LESSOREQUAL *);
  350 (* GREATEROREQUAL *);
  351 (* UNSIGNED *);
  352 (* APPLY *);
  353 (* LAMBDA *);
  354 (* WITH *);
  355 (* CONS *);
  356 (* CAR *);
  357 (* CDR *);
  358 (* NIL *);
  359 (* INL *);
  360 (* INR *);
  361 (* OUTL *);
  362 (* OUTR *);
  363 (* INJ *);
  364 (* OUT *);
  365 (* HEAD *);
  366 (* TAIL *);
  367 (* LISTCONS *);
  368 (* DISJ *);
  369 (* XOR *);
  370 (* IMPL *);
  371 (* BIIMPL *);
  372 (* CONJ *);
  373 (* NEG *);
  374 (* PROJ *);
    0|]

let yytransl_block = [|
  294 (* IDENT *);
  295 (* INTCONST *);
  296 (* RATCONST *);
  326 (* BVCONST *);
  327 (* FRESH *);
  328 (* FREE *);
    0|]

let yylhs = "\255\255\
\001\000\002\000\003\000\005\000\004\000\004\000\010\000\010\000\
\011\000\012\000\012\000\012\000\012\000\012\000\012\000\012\000\
\012\000\012\000\012\000\012\000\012\000\012\000\012\000\012\000\
\013\000\013\000\014\000\014\000\014\000\014\000\006\000\006\000\
\006\000\006\000\006\000\006\000\006\000\006\000\006\000\006\000\
\015\000\015\000\015\000\016\000\016\000\022\000\022\000\022\000\
\022\000\023\000\017\000\017\000\017\000\017\000\017\000\017\000\
\020\000\020\000\020\000\020\000\020\000\020\000\018\000\018\000\
\019\000\019\000\019\000\019\000\019\000\019\000\021\000\021\000\
\021\000\021\000\007\000\007\000\007\000\007\000\007\000\007\000\
\007\000\008\000\008\000\026\000\026\000\027\000\027\000\025\000\
\025\000\025\000\025\000\025\000\025\000\025\000\028\000\028\000\
\028\000\029\000\029\000\029\000\024\000\024\000\024\000\030\000\
\009\000\009\000\009\000\009\000\009\000\009\000\009\000\009\000\
\009\000\009\000\009\000\009\000\009\000\009\000\009\000\009\000\
\009\000\009\000\009\000\009\000\009\000\009\000\009\000\009\000\
\009\000\009\000\009\000\009\000\009\000\009\000\009\000\009\000\
\009\000\033\000\033\000\032\000\034\000\034\000\034\000\031\000\
\031\000\000\000\000\000\000\000\000\000\000\000"

let yylen = "\002\000\
\002\000\002\000\002\000\002\000\002\000\001\000\001\000\001\000\
\001\000\001\000\001\000\001\000\004\000\001\000\001\000\006\000\
\001\000\001\000\001\000\006\000\008\000\004\000\002\000\001\000\
\000\000\003\000\001\000\001\000\001\000\001\000\001\000\001\000\
\003\000\001\000\001\000\001\000\001\000\001\000\001\000\001\000\
\001\000\001\000\001\000\004\000\001\000\003\000\004\000\004\000\
\001\000\003\000\003\000\003\000\002\000\003\000\003\000\003\000\
\004\000\004\000\004\000\004\000\007\000\007\000\006\000\004\000\
\003\000\006\000\003\000\003\000\003\000\003\000\003\000\003\000\
\003\000\002\000\003\000\003\000\003\000\003\000\003\000\003\000\
\003\000\002\000\001\000\000\000\004\000\001\000\003\000\001\000\
\001\000\001\000\004\000\004\000\004\000\003\000\002\000\002\000\
\002\000\002\000\002\000\002\000\000\000\001\000\003\000\004\000\
\002\000\002\000\003\000\004\000\004\000\004\000\001\000\002\000\
\001\000\002\000\002\000\001\000\003\000\003\000\001\000\001\000\
\001\000\002\000\002\000\002\000\003\000\002\000\004\000\004\000\
\004\000\003\000\003\000\003\000\002\000\005\000\002\000\001\000\
\001\000\001\000\003\000\001\000\001\000\002\000\002\000\000\000\
\002\000\002\000\002\000\002\000\002\000\002\000"

let yydefred = "\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\014\000\009\000\
\007\000\008\000\000\000\030\000\042\000\043\000\000\000\000\000\
\000\000\028\000\029\000\011\000\000\000\012\000\000\000\015\000\
\000\000\024\000\017\000\018\000\019\000\049\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\146\000\000\000\027\000\000\000\000\000\045\000\031\000\032\000\
\034\000\035\000\036\000\037\000\038\000\039\000\040\000\147\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\148\000\
\000\000\083\000\000\000\000\000\120\000\000\000\000\000\119\000\
\000\000\000\000\000\000\116\000\111\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\136\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\006\000\149\000\000\000\000\000\137\000\150\000\000\000\
\000\000\000\000\000\000\000\000\053\000\000\000\000\000\023\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\074\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\002\000\000\000\000\000\000\000\095\000\
\096\000\097\000\003\000\000\000\082\000\000\000\000\000\105\000\
\000\000\000\000\112\000\114\000\115\000\122\000\000\000\000\000\
\000\000\000\000\000\000\140\000\000\000\142\000\143\000\000\000\
\138\000\000\000\000\000\000\000\000\000\000\000\126\000\000\000\
\133\000\000\000\123\000\000\000\005\000\004\000\033\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\056\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\081\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\094\000\145\000\107\000\
\000\000\117\000\118\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\130\000\000\000\000\000\000\000\000\000\000\000\
\022\000\013\000\026\000\057\000\058\000\059\000\060\000\000\000\
\000\000\047\000\048\000\000\000\000\000\064\000\000\000\044\000\
\000\000\092\000\091\000\093\000\086\000\000\000\098\000\099\000\
\100\000\000\000\109\000\110\000\000\000\000\000\139\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\085\000\000\000\000\000\000\000\020\000\000\000\
\000\000\000\000\016\000\066\000\063\000\087\000\000\000\000\000\
\061\000\062\000\104\000\021\000"

let yydgoto = "\006\000\
\041\000\056\000\064\000\099\000\103\000\057\000\058\000\065\000\
\101\000\043\000\044\000\045\000\112\000\046\000\047\000\048\000\
\049\000\050\000\051\000\052\000\053\000\054\000\055\000\224\000\
\067\000\157\000\022\001\068\000\238\000\027\001\162\000\173\000\
\178\000\102\000"

let yysindex = "\142\000\
\205\003\205\003\081\255\001\000\124\004\000\000\000\000\000\000\
\000\000\000\000\205\003\000\000\000\000\000\000\224\254\240\254\
\013\255\000\000\000\000\000\000\205\003\000\000\035\255\000\000\
\041\255\000\000\000\000\000\000\000\000\000\000\229\254\021\255\
\052\255\053\255\054\255\057\255\060\255\062\255\205\003\065\255\
\000\000\141\002\000\000\000\000\069\255\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\073\255\123\000\044\255\044\255\044\255\227\254\015\255\000\000\
\135\000\000\000\058\255\074\255\000\000\205\003\077\255\000\000\
\102\255\102\255\102\255\000\000\000\000\102\255\102\255\077\255\
\077\255\102\255\205\003\103\255\019\255\102\255\110\255\000\000\
\077\255\077\255\077\255\077\255\077\255\077\255\077\255\077\255\
\077\255\000\000\000\000\005\255\088\255\000\000\000\000\154\000\
\116\255\118\255\129\255\136\255\000\000\137\255\081\255\000\000\
\205\003\205\003\205\003\205\003\148\255\149\255\205\003\205\003\
\000\000\151\255\000\000\165\004\205\003\205\003\205\003\205\003\
\205\003\205\003\205\003\205\003\205\003\152\255\205\003\205\003\
\205\003\205\003\205\003\205\003\205\003\081\255\205\003\205\003\
\205\003\205\003\205\003\000\000\133\255\135\255\145\255\000\000\
\000\000\000\000\000\000\143\255\000\000\241\254\073\255\000\000\
\102\255\205\003\000\000\000\000\000\000\000\000\140\255\205\003\
\205\003\146\255\019\006\000\000\205\003\000\000\000\000\150\255\
\000\000\163\255\103\255\103\255\103\255\103\255\000\000\205\003\
\000\000\205\003\000\000\205\003\000\000\000\000\000\000\164\255\
\168\255\157\255\158\255\175\255\047\003\065\003\006\004\007\005\
\177\255\178\255\025\005\070\005\173\255\176\255\151\005\155\255\
\214\254\214\254\155\255\223\254\033\001\033\001\243\254\172\001\
\000\000\079\006\223\254\019\006\019\006\061\006\019\006\250\254\
\019\006\000\000\019\006\019\006\019\006\019\006\019\006\241\254\
\241\254\241\254\015\255\182\255\046\255\000\000\000\000\000\000\
\193\255\000\000\000\000\081\255\213\005\205\003\202\255\205\003\
\205\003\205\003\000\000\019\006\019\006\019\006\203\255\204\255\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\191\255\
\194\255\000\000\000\000\207\255\209\255\000\000\205\003\000\000\
\205\003\000\000\000\000\000\000\000\000\239\254\000\000\000\000\
\000\000\195\255\000\000\000\000\205\003\019\006\000\000\019\006\
\019\006\019\006\196\255\187\255\205\003\205\003\197\255\199\255\
\001\006\019\006\000\000\015\255\212\255\019\006\000\000\215\255\
\088\005\133\005\000\000\000\000\000\000\000\000\200\255\220\255\
\000\000\000\000\000\000\000\000"

let yyrindex = "\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\224\255\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\089\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\014\000\057\000\058\000\000\000\000\000\000\000\
\000\000\000\000\002\000\000\000\000\000\000\000\206\004\000\000\
\003\000\000\000\000\000\000\000\000\000\004\000\000\000\206\004\
\206\004\000\000\000\000\000\000\005\000\000\000\000\000\000\000\
\219\255\219\255\219\255\219\255\006\000\206\004\006\000\206\004\
\006\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\011\255\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\015\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\016\000\000\000\000\000\000\000\000\000\000\000\
\000\000\017\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\195\005\000\000\133\000\
\238\000\043\001\194\000\117\001\035\002\079\002\203\001\247\001\
\000\000\120\002\129\001\236\002\023\003\224\002\024\255\000\000\
\018\000\000\000\019\000\021\000\027\000\029\000\030\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\031\000\032\000\036\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\052\000\000\000\053\000\
\059\000\061\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\026\255\000\000\000\000\000\000\062\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000"

let yygindex = "\000\000\
\000\000\000\000\000\000\000\000\000\000\086\004\198\255\154\255\
\019\001\201\255\253\255\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\113\000\205\255\000\000\127\000\206\255\
\000\000\000\000"

let yytablesize = 1982
let yytable = "\066\000\
\098\000\084\000\113\000\121\000\141\000\144\000\153\000\154\000\
\196\000\009\000\010\000\160\000\124\000\088\000\106\000\124\000\
\135\000\076\000\075\000\152\000\077\000\124\000\106\000\009\000\
\010\000\113\000\078\000\188\000\079\000\080\000\131\000\132\000\
\236\000\125\000\126\000\125\000\127\000\128\000\107\000\226\000\
\043\001\124\000\125\000\126\000\044\001\127\000\128\000\016\001\
\129\000\174\000\175\000\108\000\127\000\009\000\010\000\017\001\
\090\000\089\000\129\000\124\000\128\000\134\000\125\000\126\000\
\101\000\127\000\128\000\108\000\129\000\163\000\164\000\165\000\
\101\000\114\000\166\000\167\000\134\000\102\000\170\000\103\000\
\125\000\126\000\176\000\127\000\128\000\102\000\129\000\103\000\
\041\000\110\000\130\000\131\000\132\000\133\000\134\000\111\000\
\062\000\136\000\063\000\024\001\135\000\025\001\237\000\240\000\
\115\000\116\000\141\000\066\000\117\000\242\000\243\000\118\000\
\119\000\142\000\120\000\136\000\137\000\138\000\008\000\122\000\
\139\000\140\000\148\000\059\000\060\000\061\000\156\000\124\000\
\248\000\249\000\250\000\251\000\067\000\062\000\155\000\063\000\
\161\000\158\000\066\000\008\000\172\000\028\001\001\000\002\000\
\003\000\004\000\005\000\177\000\125\000\126\000\189\000\127\000\
\128\000\190\000\129\000\143\000\192\000\239\000\130\000\131\000\
\132\000\133\000\134\000\144\000\145\000\146\000\147\000\193\000\
\135\000\191\000\124\000\149\000\150\000\151\000\194\000\195\000\
\237\000\237\000\237\000\021\001\018\001\019\001\020\001\136\000\
\137\000\138\000\201\000\202\000\139\000\205\000\217\000\125\000\
\126\000\070\000\127\000\128\000\232\000\129\000\233\000\235\000\
\241\000\130\000\131\000\132\000\133\000\134\000\168\000\169\000\
\234\000\124\000\244\000\135\000\001\001\002\001\246\000\179\000\
\180\000\181\000\182\000\183\000\184\000\185\000\186\000\187\000\
\247\000\255\000\136\000\137\000\138\000\000\001\003\001\139\000\
\008\001\009\001\012\001\023\001\013\001\068\000\026\001\031\001\
\066\000\035\001\036\001\037\001\054\001\039\001\038\001\040\001\
\048\001\045\001\055\001\047\001\051\001\056\001\052\001\059\001\
\144\000\069\000\070\000\071\000\072\000\073\000\074\000\075\000\
\076\000\077\000\078\000\079\000\080\000\081\000\082\000\083\000\
\084\000\085\000\086\000\060\001\025\000\087\000\088\000\104\000\
\089\000\090\000\091\000\092\000\000\000\093\000\094\000\000\000\
\000\000\095\000\096\000\097\000\000\000\007\000\008\000\009\000\
\010\000\000\000\069\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\011\000\000\000\000\000\
\000\000\084\000\000\000\000\000\000\000\000\000\000\000\000\000\
\084\000\113\000\121\000\141\000\144\000\088\000\012\000\013\000\
\014\000\015\000\016\000\017\000\088\000\106\000\124\000\135\000\
\076\000\075\000\088\000\077\000\018\000\019\000\020\000\021\000\
\022\000\078\000\023\000\079\000\080\000\131\000\132\000\024\000\
\025\000\026\000\125\000\027\000\028\000\029\000\030\000\031\000\
\032\000\033\000\034\000\035\000\036\000\037\000\038\000\041\000\
\090\000\089\000\108\000\127\000\065\000\039\000\040\000\090\000\
\089\000\129\000\041\000\128\000\134\000\090\000\089\000\000\000\
\046\000\041\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\010\000\041\000\041\000\
\041\000\000\000\000\000\000\000\000\000\000\000\041\000\041\000\
\000\000\041\000\000\000\067\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\041\000\041\000\067\000\041\000\
\041\000\000\000\041\000\041\000\000\000\067\000\041\000\041\000\
\041\000\041\000\041\000\041\000\041\000\041\000\041\000\000\000\
\041\000\000\000\067\000\000\000\067\000\000\000\000\000\000\000\
\000\000\000\000\067\000\067\000\000\000\067\000\000\000\041\000\
\041\000\041\000\054\000\000\000\041\000\000\000\000\000\000\000\
\067\000\067\000\000\000\067\000\067\000\000\000\067\000\067\000\
\070\000\000\000\067\000\067\000\067\000\067\000\067\000\067\000\
\067\000\067\000\067\000\070\000\067\000\000\000\000\000\000\000\
\000\000\000\000\070\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\067\000\067\000\067\000\055\000\070\000\
\067\000\070\000\000\000\000\000\000\000\000\000\000\000\070\000\
\070\000\000\000\070\000\000\000\068\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\070\000\070\000\068\000\
\070\000\070\000\000\000\070\000\070\000\000\000\068\000\070\000\
\070\000\070\000\070\000\070\000\070\000\070\000\070\000\070\000\
\000\000\070\000\051\000\068\000\000\000\068\000\000\000\000\000\
\000\000\000\000\000\000\068\000\068\000\000\000\068\000\000\000\
\070\000\070\000\070\000\000\000\000\000\070\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\068\000\
\068\000\069\000\000\000\068\000\068\000\068\000\068\000\068\000\
\068\000\068\000\068\000\068\000\069\000\068\000\052\000\000\000\
\000\000\000\000\000\000\069\000\000\000\000\000\000\000\124\000\
\000\000\000\000\000\000\000\000\068\000\068\000\068\000\000\000\
\069\000\068\000\069\000\000\000\000\000\000\000\000\000\000\000\
\069\000\069\000\000\000\069\000\125\000\126\000\000\000\127\000\
\128\000\000\000\129\000\000\000\000\000\000\000\000\000\050\000\
\132\000\133\000\134\000\000\000\069\000\069\000\000\000\000\000\
\069\000\069\000\069\000\069\000\069\000\069\000\069\000\069\000\
\069\000\000\000\069\000\065\000\123\000\000\000\000\000\136\000\
\000\000\000\000\000\000\000\000\000\000\000\000\065\000\046\000\
\000\000\069\000\069\000\069\000\000\000\065\000\069\000\000\000\
\000\000\000\000\046\000\000\000\000\000\000\000\000\000\000\000\
\000\000\046\000\065\000\000\000\065\000\000\000\000\000\000\000\
\000\000\000\000\065\000\065\000\000\000\065\000\046\000\000\000\
\046\000\000\000\000\000\000\000\000\000\000\000\046\000\046\000\
\000\000\046\000\000\000\000\000\000\000\000\000\000\000\065\000\
\000\000\000\000\065\000\065\000\065\000\065\000\065\000\065\000\
\065\000\065\000\065\000\046\000\065\000\000\000\046\000\046\000\
\046\000\046\000\046\000\046\000\046\000\046\000\046\000\071\000\
\046\000\054\000\124\000\065\000\065\000\065\000\000\000\000\000\
\065\000\000\000\000\000\072\000\054\000\000\000\000\000\046\000\
\046\000\046\000\000\000\054\000\046\000\000\000\000\000\125\000\
\126\000\000\000\127\000\128\000\000\000\129\000\000\000\000\000\
\054\000\000\000\054\000\132\000\000\000\134\000\000\000\000\000\
\054\000\054\000\000\000\054\000\000\000\055\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\073\000\000\000\
\055\000\000\000\136\000\000\000\000\000\054\000\000\000\055\000\
\054\000\054\000\054\000\054\000\000\000\054\000\054\000\054\000\
\054\000\000\000\054\000\000\000\055\000\000\000\055\000\000\000\
\000\000\000\000\000\000\000\000\055\000\055\000\000\000\055\000\
\000\000\051\000\054\000\054\000\000\000\000\000\054\000\000\000\
\000\000\000\000\000\000\000\000\051\000\000\000\000\000\000\000\
\000\000\055\000\000\000\051\000\055\000\055\000\000\000\055\000\
\000\000\055\000\055\000\055\000\055\000\000\000\055\000\000\000\
\051\000\000\000\051\000\000\000\000\000\000\000\000\000\000\000\
\051\000\051\000\000\000\051\000\000\000\052\000\055\000\055\000\
\000\000\000\000\055\000\000\000\000\000\000\000\000\000\000\000\
\052\000\000\000\000\000\000\000\000\000\051\000\000\000\052\000\
\051\000\051\000\000\000\000\000\000\000\051\000\051\000\051\000\
\051\000\000\000\051\000\000\000\052\000\000\000\052\000\000\000\
\000\000\000\000\000\000\000\000\052\000\052\000\050\000\052\000\
\000\000\000\000\051\000\051\000\000\000\000\000\051\000\000\000\
\000\000\050\000\000\000\000\000\000\000\000\000\000\000\000\000\
\050\000\052\000\000\000\000\000\052\000\052\000\000\000\000\000\
\000\000\052\000\052\000\052\000\052\000\050\000\052\000\050\000\
\000\000\000\000\000\000\000\000\000\000\050\000\050\000\000\000\
\050\000\000\000\000\000\000\000\000\000\000\000\052\000\052\000\
\000\000\000\000\052\000\124\000\000\000\000\000\000\000\000\000\
\000\000\000\000\050\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\050\000\050\000\050\000\050\000\000\000\050\000\
\125\000\126\000\000\000\127\000\128\000\000\000\129\000\000\000\
\000\000\000\000\130\000\131\000\132\000\133\000\134\000\050\000\
\050\000\000\000\000\000\050\000\135\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\071\000\000\000\
\000\000\000\000\000\000\136\000\137\000\138\000\000\000\000\000\
\139\000\071\000\072\000\000\000\000\000\000\000\000\000\000\000\
\071\000\000\000\000\000\000\000\000\000\072\000\000\000\000\000\
\000\000\000\000\000\000\000\000\072\000\071\000\000\000\071\000\
\000\000\000\000\000\000\000\000\000\000\071\000\071\000\000\000\
\071\000\072\000\000\000\072\000\000\000\000\000\000\000\000\000\
\000\000\072\000\072\000\000\000\072\000\073\000\000\000\000\000\
\000\000\000\000\071\000\000\000\000\000\000\000\000\000\000\000\
\073\000\000\000\071\000\071\000\071\000\071\000\072\000\073\000\
\000\000\000\000\000\000\000\000\000\000\000\000\072\000\072\000\
\072\000\072\000\000\000\000\000\073\000\000\000\073\000\071\000\
\071\000\000\000\000\000\071\000\073\000\073\000\042\000\073\000\
\000\000\100\000\100\000\000\000\000\000\000\000\000\000\000\000\
\105\000\000\000\000\000\000\000\004\001\124\000\000\000\000\000\
\000\000\073\000\109\000\000\000\000\000\000\000\000\000\000\000\
\000\000\073\000\073\000\073\000\073\000\000\000\005\001\124\000\
\000\000\000\000\125\000\126\000\121\000\127\000\128\000\000\000\
\129\000\000\000\000\000\000\000\130\000\131\000\132\000\133\000\
\134\000\000\000\000\000\000\000\125\000\126\000\135\000\127\000\
\128\000\000\000\129\000\000\000\000\000\000\000\130\000\131\000\
\132\000\133\000\134\000\159\000\000\000\136\000\137\000\138\000\
\135\000\000\000\139\000\000\000\000\000\000\000\000\000\000\000\
\171\000\000\000\000\000\000\000\000\000\000\000\000\000\136\000\
\137\000\138\000\000\000\000\000\139\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\197\000\198\000\
\199\000\200\000\000\000\000\000\203\000\204\000\000\000\000\000\
\000\000\207\000\208\000\209\000\210\000\211\000\212\000\213\000\
\214\000\215\000\216\000\000\000\218\000\219\000\220\000\221\000\
\222\000\223\000\225\000\000\000\227\000\228\000\229\000\230\000\
\231\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\007\000\008\000\009\000\010\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\011\000\245\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\252\000\000\000\253\000\
\000\000\254\000\012\000\013\000\014\000\015\000\016\000\017\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\018\000\019\000\020\000\021\000\022\000\000\000\023\000\000\000\
\000\000\000\000\000\000\024\000\025\000\026\000\000\000\027\000\
\028\000\029\000\030\000\031\000\032\000\033\000\034\000\035\000\
\036\000\037\000\038\000\006\001\124\000\000\000\000\000\000\000\
\000\000\039\000\040\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\030\001\000\000\032\001\033\001\034\001\
\000\000\125\000\126\000\000\000\127\000\128\000\000\000\129\000\
\000\000\000\000\000\000\130\000\131\000\132\000\133\000\134\000\
\000\000\000\000\000\000\000\000\041\001\135\000\042\001\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\046\001\000\000\136\000\137\000\138\000\000\000\
\000\000\139\000\049\001\050\001\069\000\070\000\071\000\072\000\
\073\000\074\000\075\000\076\000\077\000\078\000\079\000\080\000\
\081\000\082\000\083\000\084\000\085\000\086\000\000\000\000\000\
\087\000\088\000\000\000\089\000\090\000\091\000\092\000\000\000\
\093\000\094\000\000\000\000\000\095\000\096\000\097\000\000\000\
\007\000\008\000\009\000\010\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\011\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\012\000\013\000\014\000\015\000\016\000\017\000\000\000\
\000\000\007\000\008\000\206\000\010\000\000\000\000\000\018\000\
\019\000\020\000\021\000\022\000\000\000\023\000\000\000\000\000\
\000\000\011\000\024\000\025\000\026\000\000\000\027\000\028\000\
\029\000\030\000\031\000\032\000\033\000\034\000\035\000\036\000\
\037\000\038\000\012\000\013\000\014\000\015\000\016\000\017\000\
\039\000\040\000\144\000\144\000\144\000\144\000\000\000\000\000\
\018\000\019\000\020\000\021\000\022\000\000\000\023\000\000\000\
\000\000\000\000\144\000\024\000\025\000\026\000\000\000\027\000\
\028\000\029\000\030\000\031\000\032\000\033\000\034\000\035\000\
\036\000\037\000\038\000\144\000\144\000\144\000\144\000\144\000\
\144\000\039\000\040\000\000\000\000\000\000\000\000\000\000\000\
\000\000\144\000\144\000\144\000\144\000\144\000\000\000\144\000\
\000\000\000\000\000\000\000\000\144\000\144\000\144\000\000\000\
\144\000\144\000\144\000\144\000\144\000\144\000\144\000\144\000\
\144\000\144\000\144\000\144\000\007\001\124\000\000\000\000\000\
\000\000\000\000\144\000\144\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\010\001\124\000\
\000\000\000\000\125\000\126\000\000\000\127\000\128\000\000\000\
\129\000\000\000\000\000\000\000\130\000\131\000\132\000\133\000\
\134\000\000\000\000\000\000\000\125\000\126\000\135\000\127\000\
\128\000\000\000\129\000\000\000\000\000\000\000\130\000\131\000\
\132\000\133\000\134\000\000\000\000\000\136\000\137\000\138\000\
\135\000\000\000\139\000\011\001\124\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\136\000\
\137\000\138\000\000\000\000\000\139\000\057\001\124\000\000\000\
\000\000\125\000\126\000\000\000\127\000\128\000\000\000\129\000\
\000\000\000\000\000\000\130\000\131\000\132\000\133\000\134\000\
\000\000\000\000\000\000\125\000\126\000\135\000\127\000\128\000\
\000\000\129\000\000\000\000\000\000\000\130\000\131\000\132\000\
\133\000\134\000\000\000\000\000\136\000\137\000\138\000\135\000\
\000\000\139\000\058\001\124\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\136\000\137\000\
\138\000\000\000\000\000\139\000\000\000\124\000\014\001\000\000\
\125\000\126\000\000\000\127\000\128\000\000\000\129\000\015\001\
\000\000\000\000\130\000\131\000\132\000\133\000\134\000\000\000\
\000\000\000\000\125\000\126\000\135\000\127\000\128\000\000\000\
\129\000\000\000\000\000\000\000\130\000\131\000\132\000\133\000\
\134\000\000\000\000\000\136\000\137\000\138\000\135\000\000\000\
\139\000\007\000\007\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\007\000\000\000\136\000\137\000\138\000\
\000\000\000\000\139\000\124\000\000\000\000\000\007\000\007\000\
\000\000\007\000\007\000\000\000\007\000\000\000\000\000\000\000\
\007\000\007\000\007\000\007\000\007\000\000\000\000\000\000\000\
\125\000\126\000\007\000\127\000\128\000\000\000\129\000\029\001\
\000\000\000\000\130\000\131\000\132\000\133\000\134\000\000\000\
\000\000\007\000\007\000\007\000\135\000\000\000\007\000\124\000\
\053\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\136\000\137\000\138\000\000\000\000\000\
\139\000\124\000\000\000\000\000\125\000\126\000\000\000\127\000\
\128\000\000\000\129\000\000\000\000\000\000\000\130\000\131\000\
\132\000\133\000\134\000\000\000\000\000\000\000\125\000\126\000\
\135\000\127\000\128\000\000\000\129\000\000\000\000\000\000\000\
\130\000\131\000\132\000\133\000\134\000\000\000\000\000\136\000\
\137\000\138\000\135\000\124\000\139\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\136\000\137\000\138\000\000\000\124\000\139\000\000\000\
\125\000\126\000\000\000\127\000\128\000\000\000\129\000\000\000\
\000\000\000\000\130\000\131\000\132\000\133\000\134\000\000\000\
\000\000\000\000\125\000\126\000\135\000\127\000\128\000\000\000\
\129\000\000\000\000\000\000\000\130\000\131\000\132\000\133\000\
\134\000\000\000\000\000\136\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\136\000"

let yycheck = "\003\000\
\000\000\000\000\000\000\000\000\000\000\000\000\062\000\063\000\
\111\000\039\001\040\001\070\000\055\001\000\000\000\000\000\000\
\000\000\000\000\000\000\049\001\000\000\055\001\055\001\039\001\
\040\001\053\001\000\000\023\001\000\000\000\000\000\000\000\000\
\048\001\076\001\077\001\000\000\079\001\080\001\055\001\142\000\
\058\001\055\001\076\001\077\001\062\001\079\001\080\001\054\001\
\082\001\031\001\032\001\000\000\000\000\039\001\040\001\062\001\
\000\000\000\000\000\000\055\001\000\000\000\000\076\001\077\001\
\054\001\079\001\080\001\055\001\082\001\073\000\074\000\075\000\
\062\001\053\001\078\000\079\000\090\001\054\001\082\000\054\001\
\076\001\077\001\086\000\079\001\080\001\062\001\082\001\062\001\
\000\000\055\001\086\001\087\001\088\001\089\001\090\001\055\001\
\053\001\111\001\055\001\054\001\096\001\056\001\158\000\162\000\
\053\001\053\001\034\001\111\000\055\001\168\000\169\000\055\001\
\053\001\041\001\053\001\111\001\112\001\113\001\038\001\055\001\
\116\001\053\001\000\000\043\001\044\001\045\001\069\001\055\001\
\179\000\180\000\181\000\182\000\000\000\053\001\000\000\055\001\
\060\001\064\001\142\000\038\001\038\001\244\000\001\000\002\000\
\003\000\004\000\005\000\038\001\076\001\077\001\063\001\079\001\
\080\001\000\000\082\001\083\001\039\001\161\000\086\001\087\001\
\088\001\089\001\090\001\091\001\092\001\093\001\094\001\039\001\
\096\001\054\001\055\001\059\000\060\000\061\000\039\001\039\001\
\232\000\233\000\234\000\235\000\232\000\233\000\234\000\111\001\
\112\001\113\001\039\001\039\001\116\001\039\001\039\001\076\001\
\077\001\000\000\079\001\080\001\064\001\082\001\064\001\057\001\
\061\001\086\001\087\001\088\001\089\001\090\001\080\000\081\000\
\064\001\055\001\065\001\096\001\056\001\056\001\065\001\089\000\
\090\000\091\000\092\000\093\000\094\000\095\000\096\000\097\000\
\062\001\062\001\111\001\112\001\113\001\062\001\056\001\116\001\
\056\001\056\001\062\001\054\001\061\001\000\000\046\001\038\001\
\244\000\039\001\039\001\053\001\044\001\039\001\053\001\039\001\
\062\001\055\001\039\001\056\001\056\001\039\001\056\001\056\001\
\038\001\001\001\002\001\003\001\004\001\005\001\006\001\007\001\
\008\001\009\001\010\001\011\001\012\001\013\001\014\001\015\001\
\016\001\017\001\018\001\056\001\053\001\021\001\022\001\005\000\
\024\001\025\001\026\001\027\001\255\255\029\001\030\001\255\255\
\255\255\033\001\034\001\035\001\255\255\037\001\038\001\039\001\
\040\001\255\255\000\000\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\053\001\255\255\255\255\
\255\255\056\001\255\255\255\255\255\255\255\255\255\255\255\255\
\063\001\063\001\063\001\063\001\063\001\056\001\070\001\071\001\
\072\001\073\001\074\001\075\001\063\001\063\001\063\001\063\001\
\063\001\063\001\069\001\063\001\084\001\085\001\086\001\087\001\
\088\001\063\001\090\001\063\001\063\001\063\001\063\001\095\001\
\096\001\097\001\063\001\099\001\100\001\101\001\102\001\103\001\
\104\001\105\001\106\001\107\001\108\001\109\001\110\001\023\001\
\056\001\056\001\063\001\063\001\000\000\117\001\118\001\063\001\
\063\001\063\001\034\001\063\001\063\001\069\001\069\001\255\255\
\000\000\041\001\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\053\001\054\001\055\001\
\056\001\255\255\255\255\255\255\255\255\255\255\062\001\063\001\
\255\255\065\001\255\255\023\001\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\076\001\077\001\034\001\079\001\
\080\001\255\255\082\001\083\001\255\255\041\001\086\001\087\001\
\088\001\089\001\090\001\091\001\092\001\093\001\094\001\255\255\
\096\001\255\255\054\001\255\255\056\001\255\255\255\255\255\255\
\255\255\255\255\062\001\063\001\255\255\065\001\255\255\111\001\
\112\001\113\001\000\000\255\255\116\001\255\255\255\255\255\255\
\076\001\077\001\255\255\079\001\080\001\255\255\082\001\083\001\
\023\001\255\255\086\001\087\001\088\001\089\001\090\001\091\001\
\092\001\093\001\094\001\034\001\096\001\255\255\255\255\255\255\
\255\255\255\255\041\001\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\111\001\112\001\113\001\000\000\054\001\
\116\001\056\001\255\255\255\255\255\255\255\255\255\255\062\001\
\063\001\255\255\065\001\255\255\023\001\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\076\001\077\001\034\001\
\079\001\080\001\255\255\082\001\083\001\255\255\041\001\086\001\
\087\001\088\001\089\001\090\001\091\001\092\001\093\001\094\001\
\255\255\096\001\000\000\054\001\255\255\056\001\255\255\255\255\
\255\255\255\255\255\255\062\001\063\001\255\255\065\001\255\255\
\111\001\112\001\113\001\255\255\255\255\116\001\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\082\001\
\083\001\023\001\255\255\086\001\087\001\088\001\089\001\090\001\
\091\001\092\001\093\001\094\001\034\001\096\001\000\000\255\255\
\255\255\255\255\255\255\041\001\255\255\255\255\255\255\055\001\
\255\255\255\255\255\255\255\255\111\001\112\001\113\001\255\255\
\054\001\116\001\056\001\255\255\255\255\255\255\255\255\255\255\
\062\001\063\001\255\255\065\001\076\001\077\001\255\255\079\001\
\080\001\255\255\082\001\255\255\255\255\255\255\255\255\000\000\
\088\001\089\001\090\001\255\255\082\001\083\001\255\255\255\255\
\086\001\087\001\088\001\089\001\090\001\091\001\092\001\093\001\
\094\001\255\255\096\001\023\001\000\000\255\255\255\255\111\001\
\255\255\255\255\255\255\255\255\255\255\255\255\034\001\023\001\
\255\255\111\001\112\001\113\001\255\255\041\001\116\001\255\255\
\255\255\255\255\034\001\255\255\255\255\255\255\255\255\255\255\
\255\255\041\001\054\001\255\255\056\001\255\255\255\255\255\255\
\255\255\255\255\062\001\063\001\255\255\065\001\054\001\255\255\
\056\001\255\255\255\255\255\255\255\255\255\255\062\001\063\001\
\255\255\065\001\255\255\255\255\255\255\255\255\255\255\083\001\
\255\255\255\255\086\001\087\001\088\001\089\001\090\001\091\001\
\092\001\093\001\094\001\083\001\096\001\255\255\086\001\087\001\
\088\001\089\001\090\001\091\001\092\001\093\001\094\001\000\000\
\096\001\023\001\055\001\111\001\112\001\113\001\255\255\255\255\
\116\001\255\255\255\255\000\000\034\001\255\255\255\255\111\001\
\112\001\113\001\255\255\041\001\116\001\255\255\255\255\076\001\
\077\001\255\255\079\001\080\001\255\255\082\001\255\255\255\255\
\054\001\255\255\056\001\088\001\255\255\090\001\255\255\255\255\
\062\001\063\001\255\255\065\001\255\255\023\001\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\000\000\255\255\
\034\001\255\255\111\001\255\255\255\255\083\001\255\255\041\001\
\086\001\087\001\088\001\089\001\255\255\091\001\092\001\093\001\
\094\001\255\255\096\001\255\255\054\001\255\255\056\001\255\255\
\255\255\255\255\255\255\255\255\062\001\063\001\255\255\065\001\
\255\255\023\001\112\001\113\001\255\255\255\255\116\001\255\255\
\255\255\255\255\255\255\255\255\034\001\255\255\255\255\255\255\
\255\255\083\001\255\255\041\001\086\001\087\001\255\255\089\001\
\255\255\091\001\092\001\093\001\094\001\255\255\096\001\255\255\
\054\001\255\255\056\001\255\255\255\255\255\255\255\255\255\255\
\062\001\063\001\255\255\065\001\255\255\023\001\112\001\113\001\
\255\255\255\255\116\001\255\255\255\255\255\255\255\255\255\255\
\034\001\255\255\255\255\255\255\255\255\083\001\255\255\041\001\
\086\001\087\001\255\255\255\255\255\255\091\001\092\001\093\001\
\094\001\255\255\096\001\255\255\054\001\255\255\056\001\255\255\
\255\255\255\255\255\255\255\255\062\001\063\001\023\001\065\001\
\255\255\255\255\112\001\113\001\255\255\255\255\116\001\255\255\
\255\255\034\001\255\255\255\255\255\255\255\255\255\255\255\255\
\041\001\083\001\255\255\255\255\086\001\087\001\255\255\255\255\
\255\255\091\001\092\001\093\001\094\001\054\001\096\001\056\001\
\255\255\255\255\255\255\255\255\255\255\062\001\063\001\255\255\
\065\001\255\255\255\255\255\255\255\255\255\255\112\001\113\001\
\255\255\255\255\116\001\055\001\255\255\255\255\255\255\255\255\
\255\255\255\255\083\001\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\091\001\092\001\093\001\094\001\255\255\096\001\
\076\001\077\001\255\255\079\001\080\001\255\255\082\001\255\255\
\255\255\255\255\086\001\087\001\088\001\089\001\090\001\112\001\
\113\001\255\255\255\255\116\001\096\001\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\023\001\255\255\
\255\255\255\255\255\255\111\001\112\001\113\001\255\255\255\255\
\116\001\034\001\023\001\255\255\255\255\255\255\255\255\255\255\
\041\001\255\255\255\255\255\255\255\255\034\001\255\255\255\255\
\255\255\255\255\255\255\255\255\041\001\054\001\255\255\056\001\
\255\255\255\255\255\255\255\255\255\255\062\001\063\001\255\255\
\065\001\054\001\255\255\056\001\255\255\255\255\255\255\255\255\
\255\255\062\001\063\001\255\255\065\001\023\001\255\255\255\255\
\255\255\255\255\083\001\255\255\255\255\255\255\255\255\255\255\
\034\001\255\255\091\001\092\001\093\001\094\001\083\001\041\001\
\255\255\255\255\255\255\255\255\255\255\255\255\091\001\092\001\
\093\001\094\001\255\255\255\255\054\001\255\255\056\001\112\001\
\113\001\255\255\255\255\116\001\062\001\063\001\001\000\065\001\
\255\255\004\000\005\000\255\255\255\255\255\255\255\255\255\255\
\011\000\255\255\255\255\255\255\054\001\055\001\255\255\255\255\
\255\255\083\001\021\000\255\255\255\255\255\255\255\255\255\255\
\255\255\091\001\092\001\093\001\094\001\255\255\054\001\055\001\
\255\255\255\255\076\001\077\001\039\000\079\001\080\001\255\255\
\082\001\255\255\255\255\255\255\086\001\087\001\088\001\089\001\
\090\001\255\255\255\255\255\255\076\001\077\001\096\001\079\001\
\080\001\255\255\082\001\255\255\255\255\255\255\086\001\087\001\
\088\001\089\001\090\001\070\000\255\255\111\001\112\001\113\001\
\096\001\255\255\116\001\255\255\255\255\255\255\255\255\255\255\
\083\000\255\255\255\255\255\255\255\255\255\255\255\255\111\001\
\112\001\113\001\255\255\255\255\116\001\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\113\000\114\000\
\115\000\116\000\255\255\255\255\119\000\120\000\255\255\255\255\
\255\255\124\000\125\000\126\000\127\000\128\000\129\000\130\000\
\131\000\132\000\133\000\255\255\135\000\136\000\137\000\138\000\
\139\000\140\000\141\000\255\255\143\000\144\000\145\000\146\000\
\147\000\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\037\001\038\001\039\001\040\001\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\053\001\173\000\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\184\000\255\255\186\000\
\255\255\188\000\070\001\071\001\072\001\073\001\074\001\075\001\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\084\001\085\001\086\001\087\001\088\001\255\255\090\001\255\255\
\255\255\255\255\255\255\095\001\096\001\097\001\255\255\099\001\
\100\001\101\001\102\001\103\001\104\001\105\001\106\001\107\001\
\108\001\109\001\110\001\054\001\055\001\255\255\255\255\255\255\
\255\255\117\001\118\001\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\246\000\255\255\248\000\249\000\250\000\
\255\255\076\001\077\001\255\255\079\001\080\001\255\255\082\001\
\255\255\255\255\255\255\086\001\087\001\088\001\089\001\090\001\
\255\255\255\255\255\255\255\255\015\001\096\001\017\001\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\029\001\255\255\111\001\112\001\113\001\255\255\
\255\255\116\001\037\001\038\001\001\001\002\001\003\001\004\001\
\005\001\006\001\007\001\008\001\009\001\010\001\011\001\012\001\
\013\001\014\001\015\001\016\001\017\001\018\001\255\255\255\255\
\021\001\022\001\255\255\024\001\025\001\026\001\027\001\255\255\
\029\001\030\001\255\255\255\255\033\001\034\001\035\001\255\255\
\037\001\038\001\039\001\040\001\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\053\001\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\070\001\071\001\072\001\073\001\074\001\075\001\255\255\
\255\255\037\001\038\001\039\001\040\001\255\255\255\255\084\001\
\085\001\086\001\087\001\088\001\255\255\090\001\255\255\255\255\
\255\255\053\001\095\001\096\001\097\001\255\255\099\001\100\001\
\101\001\102\001\103\001\104\001\105\001\106\001\107\001\108\001\
\109\001\110\001\070\001\071\001\072\001\073\001\074\001\075\001\
\117\001\118\001\037\001\038\001\039\001\040\001\255\255\255\255\
\084\001\085\001\086\001\087\001\088\001\255\255\090\001\255\255\
\255\255\255\255\053\001\095\001\096\001\097\001\255\255\099\001\
\100\001\101\001\102\001\103\001\104\001\105\001\106\001\107\001\
\108\001\109\001\110\001\070\001\071\001\072\001\073\001\074\001\
\075\001\117\001\118\001\255\255\255\255\255\255\255\255\255\255\
\255\255\084\001\085\001\086\001\087\001\088\001\255\255\090\001\
\255\255\255\255\255\255\255\255\095\001\096\001\097\001\255\255\
\099\001\100\001\101\001\102\001\103\001\104\001\105\001\106\001\
\107\001\108\001\109\001\110\001\054\001\055\001\255\255\255\255\
\255\255\255\255\117\001\118\001\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\054\001\055\001\
\255\255\255\255\076\001\077\001\255\255\079\001\080\001\255\255\
\082\001\255\255\255\255\255\255\086\001\087\001\088\001\089\001\
\090\001\255\255\255\255\255\255\076\001\077\001\096\001\079\001\
\080\001\255\255\082\001\255\255\255\255\255\255\086\001\087\001\
\088\001\089\001\090\001\255\255\255\255\111\001\112\001\113\001\
\096\001\255\255\116\001\054\001\055\001\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\111\001\
\112\001\113\001\255\255\255\255\116\001\054\001\055\001\255\255\
\255\255\076\001\077\001\255\255\079\001\080\001\255\255\082\001\
\255\255\255\255\255\255\086\001\087\001\088\001\089\001\090\001\
\255\255\255\255\255\255\076\001\077\001\096\001\079\001\080\001\
\255\255\082\001\255\255\255\255\255\255\086\001\087\001\088\001\
\089\001\090\001\255\255\255\255\111\001\112\001\113\001\096\001\
\255\255\116\001\054\001\055\001\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\111\001\112\001\
\113\001\255\255\255\255\116\001\255\255\055\001\056\001\255\255\
\076\001\077\001\255\255\079\001\080\001\255\255\082\001\065\001\
\255\255\255\255\086\001\087\001\088\001\089\001\090\001\255\255\
\255\255\255\255\076\001\077\001\096\001\079\001\080\001\255\255\
\082\001\255\255\255\255\255\255\086\001\087\001\088\001\089\001\
\090\001\255\255\255\255\111\001\112\001\113\001\096\001\255\255\
\116\001\055\001\056\001\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\065\001\255\255\111\001\112\001\113\001\
\255\255\255\255\116\001\055\001\255\255\255\255\076\001\077\001\
\255\255\079\001\080\001\255\255\082\001\255\255\255\255\255\255\
\086\001\087\001\088\001\089\001\090\001\255\255\255\255\255\255\
\076\001\077\001\096\001\079\001\080\001\255\255\082\001\083\001\
\255\255\255\255\086\001\087\001\088\001\089\001\090\001\255\255\
\255\255\111\001\112\001\113\001\096\001\255\255\116\001\055\001\
\056\001\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\111\001\112\001\113\001\255\255\255\255\
\116\001\055\001\255\255\255\255\076\001\077\001\255\255\079\001\
\080\001\255\255\082\001\255\255\255\255\255\255\086\001\087\001\
\088\001\089\001\090\001\255\255\255\255\255\255\076\001\077\001\
\096\001\079\001\080\001\255\255\082\001\255\255\255\255\255\255\
\086\001\087\001\088\001\089\001\090\001\255\255\255\255\111\001\
\112\001\113\001\096\001\055\001\116\001\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\111\001\112\001\113\001\255\255\055\001\116\001\255\255\
\076\001\077\001\255\255\079\001\080\001\255\255\082\001\255\255\
\255\255\255\255\086\001\087\001\088\001\089\001\090\001\255\255\
\255\255\255\255\076\001\077\001\096\001\079\001\080\001\255\255\
\082\001\255\255\255\255\255\255\086\001\087\001\088\001\089\001\
\090\001\255\255\255\255\111\001\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\111\001"

let yynames_const = "\
  DROP\000\
  CAN\000\
  ASSERT\000\
  EXIT\000\
  SAVE\000\
  RESTORE\000\
  REMOVE\000\
  FORGET\000\
  RESET\000\
  SYMTAB\000\
  SIG\000\
  VALID\000\
  UNSAT\000\
  TYPE\000\
  SIGMA\000\
  SOLVE\000\
  HELP\000\
  DEF\000\
  TOGGLE\000\
  SET\000\
  TRACE\000\
  UNTRACE\000\
  CMP\000\
  FIND\000\
  USE\000\
  INV\000\
  SOLUTION\000\
  PARTITION\000\
  SHOW\000\
  CNSTRNT\000\
  SYNTAX\000\
  COMMANDS\000\
  SPLIT\000\
  DISEQ\000\
  CTXT\000\
  EOF\000\
  ARITH\000\
  TUPLE\000\
  IN\000\
  BOT\000\
  INT\000\
  NONINT\000\
  REAL\000\
  BV\000\
  TOP\000\
  INF\000\
  NEGINF\000\
  ALBRA\000\
  ACLBRA\000\
  CLBRA\000\
  LPAR\000\
  RPAR\000\
  LBRA\000\
  RBRA\000\
  LCUR\000\
  RCUR\000\
  UNDERSCORE\000\
  KLAMMERAFFE\000\
  COLON\000\
  COMMA\000\
  DOT\000\
  DDOT\000\
  ASSIGN\000\
  UNION\000\
  TO\000\
  ENDMARKER\000\
  BACKSLASH\000\
  CONC\000\
  SUB\000\
  BWITE\000\
  BWAND\000\
  BWOR\000\
  BWXOR\000\
  BWIMP\000\
  BWIFF\000\
  BWNOT\000\
  BVCONC\000\
  EQUAL\000\
  TRUE\000\
  FALSE\000\
  PLUS\000\
  MINUS\000\
  TIMES\000\
  DIVIDE\000\
  EXPT\000\
  LESS\000\
  GREATER\000\
  LESSOREQUAL\000\
  GREATEROREQUAL\000\
  UNSIGNED\000\
  APPLY\000\
  LAMBDA\000\
  WITH\000\
  CONS\000\
  CAR\000\
  CDR\000\
  NIL\000\
  INL\000\
  INR\000\
  OUTL\000\
  OUTR\000\
  INJ\000\
  OUT\000\
  HEAD\000\
  TAIL\000\
  LISTCONS\000\
  DISJ\000\
  XOR\000\
  IMPL\000\
  BIIMPL\000\
  CONJ\000\
  NEG\000\
  PROJ\000\
  "

let yynames_block = "\
  IDENT\000\
  INTCONST\000\
  RATCONST\000\
  BVCONST\000\
  FRESH\000\
  FREE\000\
  "

let yyact = [|
  (fun _ -> failwith "parser")
; (fun parser_env ->
    let _1 = (peek_val parser_env 1 : 'term) in
    Obj.repr((
# 115 "../../src/parser.mly"
                               _1 ) : Term.t))
; (fun parser_env ->
    let _1 = (peek_val parser_env 1 : 'atom) in
    Obj.repr((
# 116 "../../src/parser.mly"
                               _1 ) : Atom.t))
; (fun parser_env ->
    let _1 = (peek_val parser_env 1 : 'cnstrnt) in
    Obj.repr((
# 117 "../../src/parser.mly"
                               _1 ) : Cnstrnt.t))
; (fun parser_env ->
    let _1 = (peek_val parser_env 1 : 'command) in
    Obj.repr((
# 118 "../../src/parser.mly"
                               _1 ) : Result.t))
; (fun parser_env ->
    let _1 = (peek_val parser_env 1 : 'command) in
    Obj.repr((
# 120 "../../src/parser.mly"
                               _1 ) : Result.t))
; (fun parser_env ->
    Obj.repr((
# 121 "../../src/parser.mly"
                               raise End_of_file ) : Result.t))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : int) in
    Obj.repr((
# 124 "../../src/parser.mly"
              Q.of_int _1 ) : 'rat))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : Mpa.Q.t) in
    Obj.repr((
# 125 "../../src/parser.mly"
              _1 ) : 'rat))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : string) in
    Obj.repr((
# 129 "../../src/parser.mly"
                         Name.of_string _1 ) : 'name))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'name) in
    Obj.repr((
# 132 "../../src/parser.mly"
                                           Sym.Uninterp(_1) ) : 'funsym))
; (fun parser_env ->
    Obj.repr((
# 133 "../../src/parser.mly"
                                           Sym.Arith(Sym.Add) ) : 'funsym))
; (fun parser_env ->
    Obj.repr((
# 134 "../../src/parser.mly"
                                           Sym.Pp(Sym.Mult) ) : 'funsym))
; (fun parser_env ->
    let _3 = (peek_val parser_env 1 : int) in
    Obj.repr((
# 135 "../../src/parser.mly"
                                           Sym.Pp(Sym.Expt(_3)) ) : 'funsym))
; (fun parser_env ->
    Obj.repr((
# 136 "../../src/parser.mly"
                                           Sym.Product(Sym.Tuple) ) : 'funsym))
; (fun parser_env ->
    Obj.repr((
# 137 "../../src/parser.mly"
                                           Sym.Bvarith(Sym.Unsigned) ) : 'funsym))
; (fun parser_env ->
    let _3 = (peek_val parser_env 3 : int) in
    let _5 = (peek_val parser_env 1 : int) in
    Obj.repr((
# 138 "../../src/parser.mly"
                                           Sym.Product(Sym.Proj(_3, _5)) ) : 'funsym))
; (fun parser_env ->
    Obj.repr((
# 139 "../../src/parser.mly"
                                           Sym.Product(Sym.Tuple)  ) : 'funsym))
; (fun parser_env ->
    Obj.repr((
# 140 "../../src/parser.mly"
                                           Sym.Product(Sym.Proj(0, 2)) ) : 'funsym))
; (fun parser_env ->
    Obj.repr((
# 141 "../../src/parser.mly"
                                           Sym.Product(Sym.Proj(1, 2)) ) : 'funsym))
; (fun parser_env ->
    let _3 = (peek_val parser_env 3 : int) in
    let _5 = (peek_val parser_env 1 : int) in
    Obj.repr((
# 142 "../../src/parser.mly"
                                                         Sym.Bv(Sym.Conc(_3, _5)) ) : 'funsym))
; (fun parser_env ->
    let _3 = (peek_val parser_env 5 : int) in
    let _5 = (peek_val parser_env 3 : int) in
    let _7 = (peek_val parser_env 1 : int) in
    Obj.repr((
# 143 "../../src/parser.mly"
                                                         Sym.Bv(Sym.Sub(_3, _5, _7)) ) : 'funsym))
; (fun parser_env ->
    let _3 = (peek_val parser_env 1 : int) in
    Obj.repr((
# 144 "../../src/parser.mly"
                                                         Sym.Bv(Sym.Bitwise(_3)) ) : 'funsym))
; (fun parser_env ->
    let _2 = (peek_val parser_env 0 : 'range) in
    Obj.repr((
# 145 "../../src/parser.mly"
                                           Sym.Fun(Sym.Apply(_2)) ) : 'funsym))
; (fun parser_env ->
    Obj.repr((
# 146 "../../src/parser.mly"
                                           Sym.Fun(Sym.Abs) ) : 'funsym))
; (fun parser_env ->
    Obj.repr((
# 149 "../../src/parser.mly"
                                      None ) : 'range))
; (fun parser_env ->
    let _2 = (peek_val parser_env 1 : 'cnstrnt) in
    Obj.repr((
# 150 "../../src/parser.mly"
                                      Some(_2) ) : 'range))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'rat) in
    Obj.repr((
# 154 "../../src/parser.mly"
              Sym.Arith(Sym.Num(_1)) ) : 'constsym))
; (fun parser_env ->
    Obj.repr((
# 155 "../../src/parser.mly"
              Sym.Bv(Sym.Const(Bitv.from_string "1")) ) : 'constsym))
; (fun parser_env ->
    Obj.repr((
# 156 "../../src/parser.mly"
              Sym.Bv(Sym.Const(Bitv.from_string "0")) ) : 'constsym))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : string) in
    Obj.repr((
# 157 "../../src/parser.mly"
              Sym.Bv(Sym.Const(Bitv.from_string _1)) ) : 'constsym))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'var) in
    Obj.repr((
# 163 "../../src/parser.mly"
                     _1 ) : 'term))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'app) in
    Obj.repr((
# 164 "../../src/parser.mly"
                     _1 ) : 'term))
; (fun parser_env ->
    let _2 = (peek_val parser_env 1 : 'term) in
    Obj.repr((
# 165 "../../src/parser.mly"
                     _2 ) : 'term))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'arith) in
    Obj.repr((
# 166 "../../src/parser.mly"
                     _1 ) : 'term))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'array) in
    Obj.repr((
# 167 "../../src/parser.mly"
                     _1 ) : 'term))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'bv) in
    Obj.repr((
# 168 "../../src/parser.mly"
                     _1 ) : 'term))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'coproduct) in
    Obj.repr((
# 169 "../../src/parser.mly"
                     _1 ) : 'term))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'boolean) in
    Obj.repr((
# 170 "../../src/parser.mly"
                     _1 ) : 'term))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'list) in
    Obj.repr((
# 171 "../../src/parser.mly"
                     _1 ) : 'term))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'apply) in
    Obj.repr((
# 172 "../../src/parser.mly"
                     _1 ) : 'term))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'name) in
    Obj.repr((
# 176 "../../src/parser.mly"
          try
	    match Symtab.lookup _1 (Istate.symtab()) with
	      | Symtab.Def(a) -> a
	      | _ -> Term.mk_var _1
	  with
	      Not_found -> Term.mk_var _1 ) : 'var))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : string * int) in
    Obj.repr((
# 182 "../../src/parser.mly"
           let (x,k) = _1 in 
	   Term.mk_fresh_var (Name.of_string x) (Some(k)) ) : 'var))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : int) in
    Obj.repr((
# 184 "../../src/parser.mly"
           Term.Var(Var.mk_free _1) ) : 'var))
; (fun parser_env ->
    let _1 = (peek_val parser_env 3 : 'funsym) in
    let _3 = (peek_val parser_env 1 : 'termlist) in
    Obj.repr((
# 189 "../../src/parser.mly"
                                  Istate.sigma _1 (List.rev _3) ) : 'app))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'constsym) in
    Obj.repr((
# 190 "../../src/parser.mly"
                                  Istate.sigma _1 [] ) : 'app))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'term) in
    let _3 = (peek_val parser_env 0 : 'term) in
    Obj.repr((
# 193 "../../src/parser.mly"
                                  Coproduct.mk_inj 1 (Tuple.mk_tuple [_1; _3]) ) : 'list))
; (fun parser_env ->
    let _3 = (peek_val parser_env 1 : 'term) in
    Obj.repr((
# 194 "../../src/parser.mly"
                                  Tuple.mk_proj 0 2 (Coproduct.mk_out 1 _3) ) : 'list))
; (fun parser_env ->
    let _3 = (peek_val parser_env 1 : 'term) in
    Obj.repr((
# 195 "../../src/parser.mly"
                                  Tuple.mk_proj 1 2 (Coproduct.mk_out 1 _3) ) : 'list))
; (fun parser_env ->
    Obj.repr((
# 196 "../../src/parser.mly"
                                  Coproduct.mk_inj 0 (Tuple.mk_tuple []) ) : 'list))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'term) in
    let _3 = (peek_val parser_env 0 : 'term) in
    Obj.repr((
# 199 "../../src/parser.mly"
                                  Apply.mk_apply
				    (Context.sigma (Context.empty))
                                     None _1 [_3] ) : 'apply))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'term) in
    let _3 = (peek_val parser_env 0 : 'term) in
    Obj.repr((
# 205 "../../src/parser.mly"
                                  Arith.mk_add _1 _3 ) : 'arith))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'term) in
    let _3 = (peek_val parser_env 0 : 'term) in
    Obj.repr((
# 206 "../../src/parser.mly"
                                  Arith.mk_sub _1 _3 ) : 'arith))
; (fun parser_env ->
    let _2 = (peek_val parser_env 0 : 'term) in
    Obj.repr((
# 207 "../../src/parser.mly"
                                  Arith.mk_neg _2 ) : 'arith))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'term) in
    let _3 = (peek_val parser_env 0 : 'term) in
    Obj.repr((
# 208 "../../src/parser.mly"
                                  Sig.mk_mult _1 _3 ) : 'arith))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'term) in
    let _3 = (peek_val parser_env 0 : 'term) in
    Obj.repr((
# 209 "../../src/parser.mly"
                                  Sig.mk_div _1 _3 ) : 'arith))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'term) in
    let _3 = (peek_val parser_env 0 : int) in
    Obj.repr((
# 210 "../../src/parser.mly"
                                  Sig.mk_expt _3 _1 ) : 'arith))
; (fun parser_env ->
    let _3 = (peek_val parser_env 1 : 'term) in
    Obj.repr((
# 214 "../../src/parser.mly"
                                          Coproduct.mk_inl _3 ) : 'coproduct))
; (fun parser_env ->
    let _3 = (peek_val parser_env 1 : 'term) in
    Obj.repr((
# 215 "../../src/parser.mly"
                                          Coproduct.mk_inr _3 ) : 'coproduct))
; (fun parser_env ->
    let _3 = (peek_val parser_env 1 : 'term) in
    Obj.repr((
# 216 "../../src/parser.mly"
                                          Coproduct.mk_outl _3 ) : 'coproduct))
; (fun parser_env ->
    let _3 = (peek_val parser_env 1 : 'term) in
    Obj.repr((
# 217 "../../src/parser.mly"
                                          Coproduct.mk_outr _3 ) : 'coproduct))
; (fun parser_env ->
    let _3 = (peek_val parser_env 4 : int) in
    let _6 = (peek_val parser_env 1 : 'term) in
    Obj.repr((
# 218 "../../src/parser.mly"
                                          Coproduct.mk_inj _3 _6 ) : 'coproduct))
; (fun parser_env ->
    let _3 = (peek_val parser_env 4 : int) in
    let _6 = (peek_val parser_env 1 : 'term) in
    Obj.repr((
# 219 "../../src/parser.mly"
                                          Coproduct.mk_out _3 _6 ) : 'coproduct))
; (fun parser_env ->
    let _1 = (peek_val parser_env 5 : 'term) in
    let _3 = (peek_val parser_env 3 : 'term) in
    let _5 = (peek_val parser_env 1 : 'term) in
    Obj.repr((
# 223 "../../src/parser.mly"
                                    Arr.mk_update _1 _3 _5 ) : 'array))
; (fun parser_env ->
    let _1 = (peek_val parser_env 3 : 'term) in
    let _3 = (peek_val parser_env 1 : 'term) in
    Obj.repr((
# 224 "../../src/parser.mly"
                               Arr.mk_select _1 _3 ) : 'array))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'term) in
    let _3 = (peek_val parser_env 0 : 'term) in
    Obj.repr((
# 229 "../../src/parser.mly"
                       match Istate.width_of _1, Istate.width_of _3 with
			  | Some(n), Some(m) -> 
			      if n < 0 then
				raise (Invalid_argument ("Negative length of " ^ Term.to_string _1))
			      else if m < 0 then
				raise (Invalid_argument ("Negative length of " ^ Term.to_string _3))
			      else 
				Bitvector.mk_conc n m _1 _3
			  | Some _, _ -> 
			      raise (Invalid_argument (Term.to_string _3 ^ " not a bitvector."))
			  | _ -> 
			      raise (Invalid_argument (Term.to_string _1 ^ " not a bitvector.")) ) : 'bv))
; (fun parser_env ->
    let _1 = (peek_val parser_env 5 : 'term) in
    let _3 = (peek_val parser_env 3 : int) in
    let _5 = (peek_val parser_env 1 : int) in
    Obj.repr((
# 242 "../../src/parser.mly"
                        match Istate.width_of _1 with
			  | Some(n) -> 
			      if n < 0 then
				raise(Invalid_argument ("Negative length of " ^ Term.to_string _1))
			      else if not(0 <= _3 && _3 <= _5 && _5 < n) then
				raise(Invalid_argument ("Invalid extraction from " ^ Term.to_string _1))
			      else 
				Bitvector.mk_sub n _3 _5 _1
			  | None ->  
			      raise (Invalid_argument (Term.to_string _1 ^ " not a bitvector.")) ) : 'bv))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'term) in
    let _3 = (peek_val parser_env 0 : 'term) in
    Obj.repr((
# 252 "../../src/parser.mly"
                        Bitvector.mk_bwconj (equal_width_of _1 _3) _1 _3 ) : 'bv))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'term) in
    let _3 = (peek_val parser_env 0 : 'term) in
    Obj.repr((
# 253 "../../src/parser.mly"
                        Bitvector.mk_bwdisj (equal_width_of _1 _3) _1 _3 ) : 'bv))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'term) in
    let _3 = (peek_val parser_env 0 : 'term) in
    Obj.repr((
# 254 "../../src/parser.mly"
                        Bitvector.mk_bwimp (equal_width_of _1 _3) _1 _3 ) : 'bv))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'term) in
    let _3 = (peek_val parser_env 0 : 'term) in
    Obj.repr((
# 255 "../../src/parser.mly"
                        Bitvector.mk_bwiff (equal_width_of _1 _3) _1 _3 ) : 'bv))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'term) in
    let _3 = (peek_val parser_env 0 : 'term) in
    Obj.repr((
# 259 "../../src/parser.mly"
                              Boolean.mk_conj _1 _3 ) : 'boolean))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'term) in
    let _3 = (peek_val parser_env 0 : 'term) in
    Obj.repr((
# 260 "../../src/parser.mly"
                              Boolean.mk_disj _1 _3 ) : 'boolean))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'term) in
    let _3 = (peek_val parser_env 0 : 'term) in
    Obj.repr((
# 261 "../../src/parser.mly"
                              Boolean.mk_xor _1 _3 ) : 'boolean))
; (fun parser_env ->
    let _2 = (peek_val parser_env 0 : 'term) in
    Obj.repr((
# 262 "../../src/parser.mly"
                              Boolean.mk_neg _2 ) : 'boolean))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'term) in
    let _3 = (peek_val parser_env 0 : 'term) in
    Obj.repr((
# 267 "../../src/parser.mly"
                                      Atom.mk_equal (Fact.mk_equal _1 _3 None)) : 'atom))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'term) in
    let _3 = (peek_val parser_env 0 : 'term) in
    Obj.repr((
# 268 "../../src/parser.mly"
                                      Atom.mk_diseq (Fact.mk_diseq _1 _3 None) ) : 'atom))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'term) in
    let _3 = (peek_val parser_env 0 : 'term) in
    Obj.repr((
# 269 "../../src/parser.mly"
                                      Atom.mk_lt _1 _3 ) : 'atom))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'term) in
    let _3 = (peek_val parser_env 0 : 'term) in
    Obj.repr((
# 270 "../../src/parser.mly"
                                      Atom.mk_lt _3 _1 ) : 'atom))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'term) in
    let _3 = (peek_val parser_env 0 : 'term) in
    Obj.repr((
# 271 "../../src/parser.mly"
                                      Atom.mk_le _1 _3 ) : 'atom))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'term) in
    let _3 = (peek_val parser_env 0 : 'term) in
    Obj.repr((
# 272 "../../src/parser.mly"
                                      Atom.mk_le _3 _1 ) : 'atom))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'term) in
    let _3 = (peek_val parser_env 0 : 'cnstrnt) in
    Obj.repr((
# 273 "../../src/parser.mly"
                                      Atom.mk_in (Fact.mk_cnstrnt _1 _3 None) ) : 'atom))
; (fun parser_env ->
    let _1 = (peek_val parser_env 1 : 'interval) in
    let _2 = (peek_val parser_env 0 : 'optdiseqs) in
    Obj.repr((
# 278 "../../src/parser.mly"
                       Cnstrnt.make (_1, _2) ) : 'cnstrnt))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'name) in
    Obj.repr((
# 279 "../../src/parser.mly"
                       match Istate.type_of _1 with
			 | Some(c) -> c
			 | None ->
			    let str = Name.to_string _1 in
			    raise (Invalid_argument ("No type definition for " ^ str)) ) : 'cnstrnt))
; (fun parser_env ->
    Obj.repr((
# 286 "../../src/parser.mly"
                               Cnstrnt.Diseqs.empty ) : 'optdiseqs))
; (fun parser_env ->
    let _3 = (peek_val parser_env 1 : 'diseqs) in
    Obj.repr((
# 287 "../../src/parser.mly"
                               _3 ) : 'optdiseqs))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'rat) in
    Obj.repr((
# 290 "../../src/parser.mly"
                       Cnstrnt.Diseqs.singleton _1 ) : 'diseqs))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'diseqs) in
    let _3 = (peek_val parser_env 0 : 'rat) in
    Obj.repr((
# 291 "../../src/parser.mly"
                       Cnstrnt.Diseqs.add _3 _1 ) : 'diseqs))
; (fun parser_env ->
    Obj.repr((
# 296 "../../src/parser.mly"
                                           Interval.mk_int ) : 'interval))
; (fun parser_env ->
    Obj.repr((
# 297 "../../src/parser.mly"
                                           Interval.mk_real ) : 'interval))
; (fun parser_env ->
    Obj.repr((
# 298 "../../src/parser.mly"
                                           Interval.mk_nonint ) : 'interval))
; (fun parser_env ->
    let _2 = (peek_val parser_env 2 : 'leftendpoint) in
    let _4 = (peek_val parser_env 0 : 'rightendpoint) in
    Obj.repr((
# 299 "../../src/parser.mly"
                                           Interval.make (Dom.Nonint, _2, _4) ) : 'interval))
; (fun parser_env ->
    let _2 = (peek_val parser_env 2 : 'leftendpoint) in
    let _4 = (peek_val parser_env 0 : 'rightendpoint) in
    Obj.repr((
# 300 "../../src/parser.mly"
                                           Interval.make (Dom.Int, _2, _4) ) : 'interval))
; (fun parser_env ->
    let _2 = (peek_val parser_env 2 : 'leftendpoint) in
    let _4 = (peek_val parser_env 0 : 'rightendpoint) in
    Obj.repr((
# 301 "../../src/parser.mly"
                                           Interval.make (Dom.Real, _2, _4) ) : 'interval))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'leftendpoint) in
    let _3 = (peek_val parser_env 0 : 'rightendpoint) in
    Obj.repr((
# 302 "../../src/parser.mly"
                                           Interval.make (Dom.Real, _1, _3) ) : 'interval))
; (fun parser_env ->
    Obj.repr((
# 306 "../../src/parser.mly"
                    Endpoint.neginf ) : 'leftendpoint))
; (fun parser_env ->
    let _2 = (peek_val parser_env 0 : 'rat) in
    Obj.repr((
# 307 "../../src/parser.mly"
                    Endpoint.strict _2 ) : 'leftendpoint))
; (fun parser_env ->
    let _2 = (peek_val parser_env 0 : 'rat) in
    Obj.repr((
# 308 "../../src/parser.mly"
                    Endpoint.nonstrict _2 ) : 'leftendpoint))
; (fun parser_env ->
    Obj.repr((
# 312 "../../src/parser.mly"
                      Endpoint.posinf ) : 'rightendpoint))
; (fun parser_env ->
    let _1 = (peek_val parser_env 1 : 'rat) in
    Obj.repr((
# 313 "../../src/parser.mly"
                      Endpoint.strict _1 ) : 'rightendpoint))
; (fun parser_env ->
    let _1 = (peek_val parser_env 1 : 'rat) in
    Obj.repr((
# 314 "../../src/parser.mly"
                      Endpoint.nonstrict _1 ) : 'rightendpoint))
; (fun parser_env ->
    Obj.repr((
# 317 "../../src/parser.mly"
                        [] ) : 'termlist))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'term) in
    Obj.repr((
# 318 "../../src/parser.mly"
                        [_1] ) : 'termlist))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'termlist) in
    let _3 = (peek_val parser_env 0 : 'term) in
    Obj.repr((
# 319 "../../src/parser.mly"
                        _3 :: _1 ) : 'termlist))
; (fun parser_env ->
    let _3 = (peek_val parser_env 1 : int) in
    Obj.repr((
# 323 "../../src/parser.mly"
                              _3 ) : 'signature))
; (fun parser_env ->
    let _2 = (peek_val parser_env 0 : 'atom) in
    Obj.repr((
# 327 "../../src/parser.mly"
                              Result.Atom(Istate.can _2) ) : 'command))
; (fun parser_env ->
    let _2 = (peek_val parser_env 0 : 'term) in
    Obj.repr((
# 328 "../../src/parser.mly"
                              Result.Term(Istate.cant _2) ) : 'command))
; (fun parser_env ->
    let _2 = (peek_val parser_env 1 : 'optname) in
    let _3 = (peek_val parser_env 0 : 'atom) in
    Obj.repr((
# 329 "../../src/parser.mly"
                              Result.Process(Istate.process _2 _3) ) : 'command))
; (fun parser_env ->
    let _2 = (peek_val parser_env 2 : 'name) in
    let _4 = (peek_val parser_env 0 : 'term) in
    Obj.repr((
# 330 "../../src/parser.mly"
                              Result.Unit(Istate.def _2 _4) ) : 'command))
; (fun parser_env ->
    let _2 = (peek_val parser_env 2 : 'name) in
    let _4 = (peek_val parser_env 0 : 'signature) in
    Obj.repr((
# 331 "../../src/parser.mly"
                              Result.Unit(Istate.sgn _2 _4) ) : 'command))
; (fun parser_env ->
    let _2 = (peek_val parser_env 2 : 'name) in
    let _4 = (peek_val parser_env 0 : 'cnstrnt) in
    Obj.repr((
# 332 "../../src/parser.mly"
                              Result.Unit(Istate.typ _2 _4) ) : 'command))
; (fun parser_env ->
    Obj.repr((
# 333 "../../src/parser.mly"
                              Result.Unit(Istate.reset ()) ) : 'command))
; (fun parser_env ->
    let _2 = (peek_val parser_env 0 : 'name) in
    Obj.repr((
# 334 "../../src/parser.mly"
                              Result.Name(Istate.save(Some(_2))) ) : 'command))
; (fun parser_env ->
    Obj.repr((
# 335 "../../src/parser.mly"
                              Result.Name(Istate.save(None)) ) : 'command))
; (fun parser_env ->
    let _2 = (peek_val parser_env 0 : 'name) in
    Obj.repr((
# 336 "../../src/parser.mly"
                              Result.Unit(Istate.restore _2) ) : 'command))
; (fun parser_env ->
    let _2 = (peek_val parser_env 0 : 'name) in
    Obj.repr((
# 337 "../../src/parser.mly"
                              Result.Unit(Istate.remove _2) ) : 'command))
; (fun parser_env ->
    Obj.repr((
# 338 "../../src/parser.mly"
                              Result.Unit(Istate.forget()) ) : 'command))
; (fun parser_env ->
    let _2 = (peek_val parser_env 1 : 'optname) in
    let _3 = (peek_val parser_env 0 : 'atom) in
    Obj.repr((
# 339 "../../src/parser.mly"
                              Result.Bool(Istate.valid _2 _3) ) : 'command))
; (fun parser_env ->
    let _2 = (peek_val parser_env 1 : 'optname) in
    let _3 = (peek_val parser_env 0 : 'atom) in
    Obj.repr((
# 340 "../../src/parser.mly"
                              Result.Bool(Istate.unsat _2 _3) ) : 'command))
; (fun parser_env ->
    Obj.repr((
# 341 "../../src/parser.mly"
                              raise End_of_file ) : 'command))
; (fun parser_env ->
    Obj.repr((
# 342 "../../src/parser.mly"
                              failwith "drop" ) : 'command))
; (fun parser_env ->
    Obj.repr((
# 343 "../../src/parser.mly"
                              Result.Symtab(Istate.symtab()) ) : 'command))
; (fun parser_env ->
    let _2 = (peek_val parser_env 0 : 'name) in
    Obj.repr((
# 344 "../../src/parser.mly"
                              match Istate.entry_of _2 with
				| Some(e) -> Result.Entry(e)
				| None -> raise (Invalid_argument (Name.to_string _2 ^ "not in symbol table")) ) : 'command))
; (fun parser_env ->
    let _2 = (peek_val parser_env 0 : 'optname) in
    Obj.repr((
# 347 "../../src/parser.mly"
                              Result.Atoms(Istate.ctxt_of _2) ) : 'command))
; (fun parser_env ->
    let _2 = (peek_val parser_env 0 : 'term) in
    Obj.repr((
# 348 "../../src/parser.mly"
                              Result.Term(_2) ) : 'command))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'term) in
    let _3 = (peek_val parser_env 0 : 'term) in
    Obj.repr((
# 349 "../../src/parser.mly"
                              Result.Int(Term.cmp _1 _3) ) : 'command))
; (fun parser_env ->
    let _2 = (peek_val parser_env 0 : 'optname) in
    Obj.repr((
# 350 "../../src/parser.mly"
                              Result.Context(Istate.get_context _2) ) : 'command))
; (fun parser_env ->
    let _2 = (peek_val parser_env 2 : 'optname) in
    let _3 = (peek_val parser_env 1 : 'th) in
    let _4 = (peek_val parser_env 0 : 'term) in
    Obj.repr((
# 351 "../../src/parser.mly"
                              Result.Term(Istate.find _2 _3 _4) ) : 'command))
; (fun parser_env ->
    let _2 = (peek_val parser_env 2 : 'optname) in
    let _3 = (peek_val parser_env 1 : 'th) in
    let _4 = (peek_val parser_env 0 : 'term) in
    Obj.repr((
# 352 "../../src/parser.mly"
                              try Result.Optterm(Some(Istate.inv _2 _3 _4))
		 	      with Not_found -> Result.Optterm(None) ) : 'command))
; (fun parser_env ->
    let _2 = (peek_val parser_env 2 : 'optname) in
    let _3 = (peek_val parser_env 1 : 'th) in
    let _4 = (peek_val parser_env 0 : 'term) in
    Obj.repr((
# 354 "../../src/parser.mly"
                              Result.Terms(Istate.use _2 _3 _4) ) : 'command))
; (fun parser_env ->
    let _2 = (peek_val parser_env 1 : 'optname) in
    let _3 = (peek_val parser_env 0 : 'th) in
    Obj.repr((
# 355 "../../src/parser.mly"
                              Result.Solution(Istate.solution _2 _3) ) : 'command))
; (fun parser_env ->
    let _2 = (peek_val parser_env 1 : 'optname) in
    let _3 = (peek_val parser_env 0 : 'term) in
    Obj.repr((
# 356 "../../src/parser.mly"
                              match Istate.cnstrnt _2 _3 with
				| Some(c) -> Result.Cnstrnt(Some(c))
				| None -> Result.Cnstrnt(None) ) : 'command))
; (fun parser_env ->
    let _2 = (peek_val parser_env 1 : 'optname) in
    let _3 = (peek_val parser_env 0 : 'term) in
    Obj.repr((
# 359 "../../src/parser.mly"
                              Result.Terms(Istate.diseq _2 _3) ) : 'command))
; (fun parser_env ->
    let _2 = (peek_val parser_env 0 : 'optname) in
    Obj.repr((
# 360 "../../src/parser.mly"
                              Result.Atoms(Istate.split()) ) : 'command))
; (fun parser_env ->
    let _2 = (peek_val parser_env 3 : 'th) in
    let _3 = (peek_val parser_env 2 : 'term) in
    let _5 = (peek_val parser_env 0 : 'term) in
    Obj.repr((
# 361 "../../src/parser.mly"
                              Result.Solution(Istate.solve _2 (_3, _5)) ) : 'command))
; (fun parser_env ->
    let _2 = (peek_val parser_env 0 : 'identlist) in
    Obj.repr((
# 362 "../../src/parser.mly"
                              Result.Unit(List.iter Trace.add _2) ) : 'command))
; (fun parser_env ->
    Obj.repr((
# 363 "../../src/parser.mly"
                              Result.Unit(Trace.reset ()) ) : 'command))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'help) in
    Obj.repr((
# 364 "../../src/parser.mly"
                              Result.Unit(_1) ) : 'command))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : string) in
    Obj.repr((
# 368 "../../src/parser.mly"
                              [_1] ) : 'identlist))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'identlist) in
    let _3 = (peek_val parser_env 0 : string) in
    Obj.repr((
# 369 "../../src/parser.mly"
                              _3 :: _1 ) : 'identlist))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : string) in
    Obj.repr((
# 372 "../../src/parser.mly"
             failwith "to do" ) : 'th))
; (fun parser_env ->
    Obj.repr((
# 375 "../../src/parser.mly"
                              Help.on_help () ) : 'help))
; (fun parser_env ->
    Obj.repr((
# 376 "../../src/parser.mly"
                              Help.syntax () ) : 'help))
; (fun parser_env ->
    Obj.repr((
# 377 "../../src/parser.mly"
                              Help.commands () ) : 'help))
; (fun parser_env ->
    Obj.repr((
# 381 "../../src/parser.mly"
                              None ) : 'optname))
; (fun parser_env ->
    let _2 = (peek_val parser_env 0 : 'name) in
    Obj.repr((
# 382 "../../src/parser.mly"
                              Some(_2) ) : 'optname))
(* Entry termeof *)
; (fun parser_env -> raise (YYexit (peek_val parser_env 0)))
(* Entry atomeof *)
; (fun parser_env -> raise (YYexit (peek_val parser_env 0)))
(* Entry cnstrnteof *)
; (fun parser_env -> raise (YYexit (peek_val parser_env 0)))
(* Entry commands *)
; (fun parser_env -> raise (YYexit (peek_val parser_env 0)))
(* Entry commandseof *)
; (fun parser_env -> raise (YYexit (peek_val parser_env 0)))
|]
let yytables =
  { actions=yyact;
    transl_const=yytransl_const;
    transl_block=yytransl_block;
    lhs=yylhs;
    len=yylen;
    defred=yydefred;
    dgoto=yydgoto;
    sindex=yysindex;
    rindex=yyrindex;
    gindex=yygindex;
    tablesize=yytablesize;
    table=yytable;
    check=yycheck;
    error_function=parse_error;
    names_const=yynames_const;
    names_block=yynames_block }
let termeof (lexfun : Lexing.lexbuf -> token) (lexbuf : Lexing.lexbuf) =
   (yyparse yytables 1 lexfun lexbuf : Term.t)
let atomeof (lexfun : Lexing.lexbuf -> token) (lexbuf : Lexing.lexbuf) =
   (yyparse yytables 2 lexfun lexbuf : Atom.t)
let cnstrnteof (lexfun : Lexing.lexbuf -> token) (lexbuf : Lexing.lexbuf) =
   (yyparse yytables 3 lexfun lexbuf : Cnstrnt.t)
let commands (lexfun : Lexing.lexbuf -> token) (lexbuf : Lexing.lexbuf) =
   (yyparse yytables 4 lexfun lexbuf : Result.t)
let commandseof (lexfun : Lexing.lexbuf -> token) (lexbuf : Lexing.lexbuf) =
   (yyparse yytables 5 lexfun lexbuf : Result.t)
