type token =
    DROP
  | CAN
  | ASSERT
  | EXIT
  | SAVE
  | RESTORE
  | REMOVE
  | FORGET
  | RESET
  | SYMTAB
  | SIG
  | VALID
  | UNSAT
  | TYPE
  | SIGMA
  | SOLVE
  | HELP
  | DEF
  | TOGGLE
  | SET
  | TRACE
  | UNTRACE
  | CMP
  | FIND
  | USE
  | INV
  | SOLUTION
  | PARTITION
  | SHOW
  | CNSTRNT
  | SYNTAX
  | COMMANDS
  | SPLIT
  | DISEQ
  | CTXT
  | EOF
  | ARITH
  | TUPLE
  | IDENT of (string)
  | INTCONST of (int)
  | RATCONST of (Mpa.Q.t)
  | IN
  | BOT
  | INT
  | NONINT
  | REAL
  | BV
  | TOP
  | INF
  | NEGINF
  | ALBRA
  | ACLBRA
  | CLBRA
  | LPAR
  | RPAR
  | LBRA
  | RBRA
  | LCUR
  | RCUR
  | UNDERSCORE
  | KLAMMERAFFE
  | COLON
  | COMMA
  | DOT
  | DDOT
  | ASSIGN
  | UNION
  | TO
  | ENDMARKER
  | BACKSLASH
  | BVCONST of (string)
  | FRESH of (string * int)
  | FREE of (int)
  | CONC
  | SUB
  | BWITE
  | BWAND
  | BWOR
  | BWXOR
  | BWIMP
  | BWIFF
  | BWNOT
  | BVCONC
  | EQUAL
  | TRUE
  | FALSE
  | PLUS
  | MINUS
  | TIMES
  | DIVIDE
  | EXPT
  | LESS
  | GREATER
  | LESSOREQUAL
  | GREATEROREQUAL
  | UNSIGNED
  | APPLY
  | LAMBDA
  | WITH
  | CONS
  | CAR
  | CDR
  | NIL
  | INL
  | INR
  | OUTL
  | OUTR
  | INJ
  | OUT
  | HEAD
  | TAIL
  | LISTCONS
  | DISJ
  | XOR
  | IMPL
  | BIIMPL
  | CONJ
  | NEG
  | PROJ

val termeof :
  (Lexing.lexbuf  -> token) -> Lexing.lexbuf -> Term.t
val atomeof :
  (Lexing.lexbuf  -> token) -> Lexing.lexbuf -> Atom.t
val cnstrnteof :
  (Lexing.lexbuf  -> token) -> Lexing.lexbuf -> Cnstrnt.t
val commands :
  (Lexing.lexbuf  -> token) -> Lexing.lexbuf -> Result.t
val commandseof :
  (Lexing.lexbuf  -> token) -> Lexing.lexbuf -> Result.t
